'*******************************************************************************
'*                             Graphics.bi                                     *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "windows.bi"
#include once "win/commctrl.bi"

namespace Colors
          #Define cl3DShadow            GetSysColor(COLOR_3DDKSHADOW)
          #Define cl3DFace              GetSysColor(COLOR_3DFACE) 
          #Define clBtnFace             GetSysColor(COLOR_BTNFACE)
          #Define cl3DHighlight         GetSysColor(COLOR_3DHILIGHT)
          #Define cl3DLight             GetSysColor(COLOR_3DLIGHT)
          #Define cl3DShodow            GetSysColor(COLOR_3DSHADOW)
          #Define clActiveBorder        GetSysColor(COLOR_ACTIVEBORDER)
          #Define clActiveCaption       GetSysColor(COLOR_ACTIVECAPTION)
          #Define clAppWorkSpace        GetSysColor(COLOR_APPWORKSPACE)
          #Define clBackground          GetSysColor(COLOR_BACKGROUND)
          #Define clBtnText             GetSysColor(COLOR_BTNTEXT)
          #Define clCaptionText         GetSysColor(COLOR_CAPTIONTEXT)
          #Define clGrayText            GetSysColor(COLOR_GRAYTEXT)
          #Define clHighlight           GetSysColor(COLOR_HIGHLIGHT)
          #Define clHighlightText       GetSysColor(COLOR_HIGHLIGHTTEXT)
          #Define clInactiveBorder      GetSysColor(COLOR_INACTIVEBORDER)
          #Define clInactiveCaption     GetSysColor(COLOR_INACTIVECAPTION)
          #Define clInactiveCaptionText GetSysColor(COLOR_INACTIVECAPTIONTEXT)
          #Define clInfoBK              GetSysColor(COLOR_INFOBK)
          #Define clInfoText            GetSysColor(COLOR_INFOTEXT)
          #Define clMenu                GetSysColor(COLOR_MENU)
          #Define clMenuText            GetSysColor(COLOR_MENUTEXT)
          #Define clScrollBar           GetSysColor(COLOR_SCROLLBAR)
          #Define clWindow              GetSysColor(COLOR_WINDOW)
          #Define clWindowFrame         GetSysColor(COLOR_WINDOWFRAME)
          #Define clWindowText          GetSysColor(COLOR_WINDOWTEXT)
          
          Const clBlack        = &H000000
          Const clWhite        = &HFFFFFF
          Const clBlue         = &HFF0000
          Const clGreen        = &H8000
          Const clRed          = &H0000FF
          Const clGray         = &H808080
          Const clSilver       = &HC0C0C0
          Const clYellow       = &HFFFF
          Const clPurple       = &HFF00FF
          Const clAqua         = &HFF0000
          Const clMaron        = &H000097
          Const clNavy         = &H910000
          Const clCyan         = &H808000 
          Const clMagenta      = &H800080
          Const clBrown        = &H8080
          Const clLightBlue    = &HFF0000
          Const clLightGreen   = &HFF00
          Const clLightCyan    = &HFFFF00
          Const clLightMagenta = &HFF00FF
end namespace

namespace Cursors
         #Define crArrow       LoadCursor(0,IDC_ARROW)
         #Define crIBeam       LoadCursor(0,IDC_IBEAM)
         #Define crWait        LoadCursor(0,IDC_WAIT)
         #Define crCross       LoadCursor(0,IDC_CROSS)
         #Define crUpArrow     LoadCursor(0,IDC_UPARROW)
         #Define crSizeNWSE    LoadCursor(0,IDC_SIZENWSE)
         #Define crSizeNESW    LoadCursor(0,IDC_SIZENESW)
         #Define crSizeWE      LoadCursor(0,IDC_SIZEWE)
         #Define crSizeNS      LoadCursor(0,IDC_SIZENS)
         #Define crSizeAll     LoadCursor(0,IDC_SIZEALL)
         #Define crNo          LoadCursor(0,IDC_NO)
         #Define crAppStarting LoadCursor(0,IDC_APPSTARTING)
         #Define crHelp        LoadCursor(0,IDC_HELP)
end namespace

namespace Icons
         #Define icApplication LoadIcon(0,IDI_APPLICATION)
         #Define icHand        LoadIcon(0,IDI_HAND)
         #Define icQuestion    LoadIcon(0,IDI_QUESTION)
         #Define icExclamation LoadIcon(0,IDI_EXCLAMATION)
         #Define icAsterisk    LoadIcon(0,IDI_ASTERISK)
         #Define icWinLogo     LoadIcon(0,IDI_WINLOGO)
end namespace

declare function ColorToRGB(FColor as integer) as integer
declare function RGBToColor(R as byte,G as byte,B as byte) as integer
declare function GetRed(FColor as integer) as byte
declare function GetGreen(FColor as integer) as byte
declare function GetBlue(FColor as integer) as byte

enum TBrushStyle
    bsSolid   = BS_SOLID
    bsClear   = BS_NULL
    bsHatch   = BS_HATCHED
    bsPattern = BS_PATTERN
end enum

enum THatchStyle
    hsHorizontal = HS_HORIZONTAL
    hsVertical   = HS_VERTICAL
    hsFDiagonal  = HS_FDIAGONAL
    hsDiagonal   = HS_BDIAGONAL
    hsCross      = HS_CROSS
    hsDiagCross  = HS_DIAGCROSS
end enum

enum TPenStyle
    psSolid       = PS_SOLID
    psDot         = PS_DOT
    psDash        = PS_DASH
    psDashDot     = PS_DASHDOT
    psDashDotDot  = PS_DASHDOTDOT
    psInsideFrame = PS_INSIDEFRAME
end enum

enum TPenMode
    pmBlack       = R2_BLACK
    pmCopyPen     = R2_COPYPEN
    pmMaskNotPen  = R2_MASKNOTPEN
    pmMaskPen     = R2_MASKPEN
    pmMaskPenNot  = R2_MASKPENNOT
    pmMergeNotPen = R2_MERGENOTPEN
    pmMergePen    = R2_MERGEPEN
    pmMergePenNot = R2_MERGEPENNOT
    pmNop         = R2_NOP
    pmNot         = R2_NOT
    pmNotCopyPen  = R2_NOTCOPYPEN
    pmNotMaskPen  = R2_NOTMASKPEN
    pmNotMergePen = R2_NOTMERGEPEN
    pmNotXorPen   = R2_NOTXORPEN
    pmWhite       = R2_WHITE
    pmXorPen      = R2_XORPEN
end enum

enum TDrawingStyle
     dsFocus       = ILD_FOCUS
     dsNormal      = ILD_NORMAL
     dsSelected    = ILD_SELECTED
     dsTransparent = ILD_TRANSPARENT
     dsBlend       = ILD_BLEND
     dsBlend25     = ILD_BLEND25
     dsBlend50     = ILD_BLEND50
end enum

enum TImageType
     itImage = 0
     itMask  = ILD_MASK
end enum 

#define TPenClass(__Ptr__) *cast(TPen ptr,__Ptr__)

type PPen as TPen Ptr
type TPen
    private:
    FMode  as integer=pmCopyPen
    FColor as integer
    FStyle as integer
    FWidth as integer
    Declare Sub Create
    public:
    Handle as HPEN
    Tag    as integer
    declare property Mode as integer
    declare property Mode(value as integer)
    declare property Color as integer
    declare property Color(Value as integer)
    declare property Style as integer
    declare property Style(Value as integer)
    declare property Width as integer
    declare property Width(Value as integer)
    declare operator Let(Value as hPen)
    declare operator Let(Value as TPen)
    declare operator cast as any ptr
    declare operator cast as string
    declare constructor(AStyle as integer=ps_solid,AColor as integer=0,AWidth as integer=1)
    declare destructor
end type

#define TBrushClass(__Ptr__) *cast(TBrush ptr,__Ptr__)

type PBrush as TBrush Ptr
type TBrush
    private:
    FColor as integer
    FStyle as integer
    FHatch as integer
    declare sub Create
    public:
    Handle as hBrush
    Tag    as integer
    declare property Color as integer
    declare property Color(Value as integer)
    declare property Style as integer
    declare property Style(Value as integer)
    declare property Hatch as integer
    declare property Hatch(Value as integer)
    declare operator Let(Value as hBrush)
    declare operator Let(Value as TBrush)
    declare operator cast as Any Ptr
    declare constructor(AStyle as integer=bs_solid,AColor as integer=GetSysColor(color_window),AHatch as integer=0)
    declare destructor
end type

#define TCursorClass(__Ptr__) *cast(TCursor ptr,__Ptr__)

type PCursor as TCursor ptr
type TCursor
    private:
    FWidth     as integer
    FHeight    as integer
    FHotSpotX  as integer
    FHotSpotY  as integer
    declare sub Create
    public:
    Graphic    as Any Ptr
    Handle     as HCURSOR
    Tag        as integer
    declare property Width as integer
    declare property Width(value as integer)
    declare property Height as integer
    declare property Height(value as integer)
    declare property HotSpotX as integer
    declare property HotSpotX(value as integer)
    declare property HotSpotY as integer
    declare property HotSpotY(value as integer)
    declare sub LoadFromFile(File as string)
    declare sub SaveToFile(File as string)
    declare sub LoadFromResourceName(ResName as string,hInstance as hmodule=GetModuleHandle(0))
    declare sub LoadFromResourceID(ResID as integer,hInstance as hmodule=GetModuleHandle(0))
    declare operator cast as any ptr
    declare operator let(value as string)
    declare operator let(value as HCURSOR)
    declare operator let(value as TCursor)
    declare constructor
    declare destructor
    Changed as sub(ByRef Sender as TCursor)
end type

#define TIconClass(__Ptr__) *cast(TIcon ptr,__Ptr__)

type PIcon as TIcon ptr
type TIcon
    private:
    FWidth    as integer
    FHeight   as integer
    public:
    Graphic   as any ptr
    Handle    as HICON
    Tag       as integer
    declare property Width as integer
    declare property Width(value as integer)
    declare property Height as integer
    declare property Height(value as integer)
    declare sub LoadFromFile(File as string)
    declare sub SaveToFile(File as string)
    declare sub LoadFromResourceName(ResName as string,hInstance as hmodule=GetModuleHandle(0))
    declare sub LoadFromResourceID(ResID as integer,hInstance as hmodule=GetModuleHandle(0))
    declare operator cast as any ptr
    declare operator cast as string
    declare operator let(value as string)
    declare operator let(value as HICON)
    declare operator let(value as TIcon)
    declare constructor
    declare destructor
    Changed as sub(ByRef Sender as TIcon)
end type

#define TFontClass(__Ptr__) *cast(TFont ptr,__Ptr__)

type PFont as TFont ptr
type TFont
    private:
    FColor        as integer
    FBold         as integer
    FItalic       as integer 
    FUnderline    as integer
    FStrikeout    as integer
    FSize         as integer
    FCharset      as integer
    FName         as string
    fWindowHandle as hwnd
    declare sub Create
    public:
    Control       as any ptr
    Handle        as hFont
    Tag           as integer
    declare property WindowHandle as hwnd
    declare property WindowHandle(value as hwnd)
    declare property Color as integer
    declare property Color(value as integer)
    declare property Bold as integer
    declare property Bold(value as integer)
    declare property Italic as integer
    declare property Italic(value as integer)
    declare property Underline as integer
    declare property Underline(value as integer)
    declare property Strikeout as integer
    declare property Strikeout(value as integer)
    declare property Charset as integer
    declare property Charset(value as integer)
    declare property Size as integer
    declare property Size(value as integer)
    declare property Name as string
    declare property Name(value as string)
    declare operator let(value as hFont)
    declare operator let(value as TFont)
    declare operator cast as any ptr
    declare constructor
    declare destructor
    Changed as sub(ByRef Sender as TFont)
end type

#undef PBitmap '''!  

#define TBitmapClass(__Ptr__) *cast(TBitmap ptr,__Ptr__)

type PBitmap as TBitmap ptr
type TBitmap
    private:
    FPixelFormat      as integer
    FWidth            as integer
    FHeight           as integer
    FTransparent      as integer
    FTransparentColor as integer
    FMask             as hbitmap
    FHandle           as hbitmap
    FDevice            as hdc
    declare sub MakeMask(Dc as hdc)
    declare sub GetInfo
    public:
    CopyMode          as integer
    Graphic           as any ptr
    Brush             as TBrush
    Pen               as TPen
    Font              as TFont
    Tag               as integer
    declare property Device as hdc
    declare property Device(value as hdc)
    declare property Handle as hbitmap
    declare property Handle(value as hbitmap)
    declare property Mask as hbitmap
    declare property Mask(value as hbitmap)
    declare property PixelFormat as integer
    declare property PixelFormat(value as integer)
    declare property Transparency as integer
    declare property Transparency(value as integer)
    declare property TransparentColor as integer
    declare property TransparentColor(value as integer)
    declare property Width as integer
    declare property Width(value as integer)
    declare property Height as integer
    declare property Height(value as integer)
    declare sub StretchDrawTransparent(Dc as hdc,x as integer,y as integer,cx as integer,cy as integer)
    declare sub DrawTransparent(Dc as hdc,x as integer,y as integer)
    declare sub StretchDraw(Dc as hdc,x as integer,y as integer,cx as integer,cy as integer)
    declare sub Draw(Dc as hdc,x as integer,y as integer)
    declare sub Copy(x as integer,y as integer,Source as TBitmap)
    declare sub CopyRect(R as Rect,Source as TBitmap)
    declare sub LoadFromFile(File as string)
    declare sub SaveToFile(File as string)
    declare sub LoadFromResourceName(ResName as string,hInstance as hmodule=GetModuleHandle(0))
    declare sub LoadFromResourceID(ResID as integer,hInstance as hmodule=GetModuleHandle(0))
    declare sub MoveTo(x as integer, y as integer)
    declare sub LineTo(x as integer, y as integer)
    declare sub Line(x as integer, y as integer, x1 as integer, y1 as integer)
    declare sub TextOut(x as integer, y as integer, Text as string)
    declare sub FillRect(R as rect)
    declare sub Rectangle(x as integer, y as integer, x1 as integer, y1 as integer)
    declare sub Ellipse(x as integer, y as integer, x1 as integer, y1 as integer)
    declare sub RoundRect(x as integer, y as integer, x1 as integer, y1 as integer,rx as integer,ry as integer)
    declare operator cast as any ptr
    declare operator cast as string
    declare operator let(value as string)
    declare operator let(value as hbitmap)
    declare operator let(value as TBitmap)
    declare constructor
    declare destructor
    Changed as sub(ByRef Sender as TBitmap)
end type

#define TGraphicClass(__Ptr__) *cast(TGraphic ptr,__Ptr__)

type PGraphic as TGraphic ptr
type TGraphic
     private:
     declare Static sub IconChanged(Byref Sender as TIcon)
     declare Static sub CursorChanged(Byref Sender as TCursor)
     declare Static sub BitmapChanged(Byref Sender as TBitmap)
     public:
     Control   as any ptr
     Imagetype as integer
     Image     as any ptr 
     Icon      as TIcon
     Cursor    as TCursor
     Bitmap    as TBitmap
     'EMF      as TEMF
     declare operator cast as any ptr
     declare operator cast as string
     declare constructor
     declare destructor
     onChange as sub(byref Sender as TGraphic)
end type

#define TImageListClass(__Ptr__) *cast(TImageList ptr,__Ptr__)

type PImageList as TImageList ptr
type TImageList
    private:
    FWindowHandle as hwnd
    FWidth        as integer
    FHeight       as integer
    FBKColor      as integer
    FCount        as integer
    declare sub Create
    declare sub NotifyControl
    public:
    Handle        as himagelist
    AllocBy       as integer
    Imagetype     as TImagetype
    DrawingStyle  as TDrawingStyle
    declare property WindowHandle as hwnd
    declare property WindowHandle(value as hwnd)
    declare property Width as integer
    declare property Width(value as integer)
    declare property Height as integer
    declare property Height(value as integer)
    declare property BKColor as integer
    declare property BKColor(value as integer)
    declare property Count as integer
    declare sub AddIcon(Icon as TIcon)
    declare sub AddBitmap(Bitmap as TBitmap,Mask as TBitmap)
    declare sub AddCursor(Cursor as TCursor)
    declare sub AddMasked(byref Bitmap as TBitmap,MaskColor as integer)
    declare function GetBitmap(Index as integer) as TBitmap
    declare function GetMask(Index as integer) as TBitmap
    declare function GetIcon(Index as integer) as TIcon
    declare function GetCursor(Index as integer) as TCursor
    declare sub Remove(Index as integer)
    declare sub DrawEx(Index as integer,DestDC as HDC,X as integer,Y as integer,iWidth as integer,iHeight as integer,FG as integer,BK as integer)
    declare sub Draw(Index as integer,DestDC as HDC,X as integer,Y as integer)
    declare sub Clear
    declare operator cast as any ptr
    declare operator cast as string
    declare constructor
    declare destructor
    OnChange as sub(byref Sender as TImageList) 
end type
